# Reactor desktop application

Features list
- Communication with the device using reactor-com
	- Serial port implementation
	- Bluetooth (future)
- Monitoring device's parameters
	- Temperature sensors, where number of sensors is usually about 1 to 3
	- Current (ammpers unit) and power (watts unit) for battery
		- Charging
		- Discharging
	- Battery status flags
		- Charging
		- Discharging
		- Protected
		- Locked
	- Protection flags
		- Cell overvoltage
		- Cell undervoltage
		- Charging overtemperature
		- Charging undertemperature
		- Discharging overtemperature
		- Discharging undertemperature
		- Charging overcurrent
		- Discharging overcurrent
	- Cell monitor (usually 10 to 16 cells)
		- Voltage (mili volts unit)
		- Balancing flag (on/off)
		- Overvoltage event (on/off)
		- Undervoltage event (on/off)
		- Internal resistance (micro ohms unit)
	- Battery capacity
		- Nominal (mAh unit)
		- Estimated (mAh unit)
	- Capacity limit
		- 50% to 100% capacity limit slider
		- Expected vitality gain (will be fetched from the device)
- Setting device's parameters
	- Overvoltage (per cell) limit in mili volts
	- Undervoltage (per cell) limit in mili volts
	- Maximum charging current
	- Maximum discharging current
	- Maximum and minimum charging temperature
	- Maximum and minimum discharging temperature
	- Capacity limit (50% to 100%)
	- Balancing mode (never, charging, always)
- Locking and unlocking the battery

# Configuration view parameters
- cell
	- overvoltage value
		- property cell-ov
		- widget SpinButton
		- unit mV
		- range 0:10000
		- step 1
	- overvoltage release
		- property cell-ov-release
		- widget SpinButton
		- unit mV
		- range 0:9999
		- step 1
	- undervoltage value 
		- property cell-uv
		- widget SpinButton
		- unit mV
		- range 0:9999
		- step 1
	- undervoltage release
		- property cell-uv-release
		- widget SpinButton
		- unit mV
		- range 0:9999
		- step 1
- charging
	- overcurrent value
		- property chg-current-limit
		- widget SpinButton
		- unit A
		- range 0:999
		- step 0.1
	- overcurrent delay
		- property chg-current-delay
		- widget SpinButton
		- unit s
		- range 0:999
		- step 0.1
	- min temperature 
		- property chg-temperature-min
		- widget SpinButton
		- unit C degree
		- range -80:99
		- step 1
	- max temperature
		- property chg-temperature-max
		- widget SpinButton
		- unit C degree
		- range -80:99
		- step 1
- discharging
	- overcurrent value
		- property dsg-current-limit
		- widget SpinButton
		- unit A
		- range 0:999
		- step 0.1
	- overcurrent delay
		- property dsg-current-delay
		- widget SpinButton
		- unit s
		- range 0:999
		- step 0.1
	- min temperature
		- property dsg-temperature-min
		- widget SpinButton
		- unit C degree
		- range -80:99
		- step 1
	- max temperature
		- property dsg-temperature-max
		- widget SpinButton
		- unit C degree
		- range -80:99
		- step 1
- nominal parameters
	- capacity
		- property nominal-capacity
		- widget SpinButton
		- unit mAh
		- range 0:100000
		- step 1
	- voltage
		- property nominal-voltage
		- widget SpinButton
		- unit V
		- range 0:1000
		- step 0.1
- voltage to capacity function
	- polynomial
		- property capacity-polynomial
		- widget $polynomial_widget
- capacity limit to vitality gain function
	- polynomial
		- property vitality-polynomial
		- widget $polynomial_widget
